import {BlockRaycastOptions, world, MinecraftBlockTypes, BlockLocation, EntityQueryOptions} from 'mojang-minecraft';
    
const breakBlock = world.events.blockBreak;
const placeBlock = world.events.blockPlace;
const explodeBlock = world.events.blockExplode;
const bChat = world.events.beforeChat;
bChat.subscribe(beforeChat);
breakBlock.subscribe(blockBreak);
placeBlock.subscribe(blockPlace);
explodeBlock.subscribe(blockExplode);

function beforeChat(eventData){
let source = eventData.sender;
let msg = eventData.message;
let myTag;
	if(msg.includes('!bp')){
		eventData.cancel = true;
		checkForGlobalEntity();
		let args = msg.split(' ');
		switch(args[1]){
			case 'remove':
			//remove your own block history and from the global tag
			myTag = (source.getTags()).find(tag => tag.includes('bb-{'));
			let myTagDb = tagToJson(myTag);
			let newJson = 'bb-{xyblocksxy:[]}';
			source.removeTag(myTag);
			source.addTag(newJson);
			newJson = tagToJson(newJson);
			newJson.blocks = getGlobalDb().blocks.filter(db => !myTagDb.blocks.includes(db));
			let globalBlockRec = world.getDimension(`overworld`).getEntitiesAtBlockLocation(new BlockLocation(0,-64,0));
			if(getGlobalDb().blocks.length<=0) return;
			globalBlockRec[0].removeTag(jsonToTag(getGlobalDb())); 
			globalBlockRec[0].addTag(jsonToTag(newJson));
			source.runCommand(`tellraw @s {"rawtext":[{"text":"§a[Block Protection]Removed block history protection!"}]}`);	
			break;
			
			case 'history':
			myTag = (source.getTags()).find(tag => tag.includes('bb-{'));
			//source.runCommand(`tellraw @s {"rawtext":[{"text":"§a[Block Protection]'${JSON.stringify(tagToJson(myTag))}'"}]}`);	
			source.dimension.runCommand(`tell @a[name="${source.nameTag}"] §a${JSON.stringify(tagToJson(myTag))}`);
			break;
			
			case 'removeall':
			if(source.hasTag('op')){
			let allPlayers = Array.from(world.getPlayers());
			for(let index in allPlayers){
				let player = allPlayers[index];
				myTag = (player.getTags()).find(tag => tag.includes('bb-{'));
				let myTagDb = tagToJson(myTag);
				let newJson = 'bb-{xyblocksxy:[]}';
				player.removeTag(myTag);
				player.addTag(newJson);
				let globalBlockRec = world.getDimension(`overworld`).getEntitiesAtBlockLocation(new BlockLocation(0,-64,0));
				globalBlockRec[0].kill();
				let spawnGlobalRec = world.getDimension('overworld').spawnEntity('bp:globalrec',new BlockLocation(0,-64,0));
				spawnGlobalRec.addTag(newJson);
				source.runCommand(`tellraw @a {"rawtext":[{"text":"§a[Block Protection]Removed all player's block history protection!"}]}`);
			}
			}else{
			source.runCommand(`tellraw @a {"rawtext":[{"text":"§c[Block Protection]Requires OP!"}]}`);	
			}
			break;
			
			default:
			source.runCommand(`tellraw @s {"rawtext":[{"text":"§a=>Block Protection<=\n- !bp remove (Remove your block history protection)\n- !bp removeall (Remove all player's block history protection)\n- !bp history (Your block protection history)"}]}`);	
		}
	}
}

function blockExplode(eventData){
let block = eventData.block;
let blockPermu = eventData.destroyedBlockPermutation;
let blockLoc = block.location;
let dimension = eventData.dimension;
let x = blockLoc.x;
let y = blockLoc.y;
let z = blockLoc.z; 
let globalDb = getGlobalDb();
let index = globalDb.blocks.findIndex(loc => loc.includes(`${x}:${y}:${z}`));
	if(index>=0){
	block.setPermutation(blockPermu);
		if(blockPermu.type.id == 'minecraft:chest'){
			//plan to put back items into chest 
		}
	try{
		dimension.runCommand(`execute @e[x=${x},y=${y},z=${z},r=2,type=item,c=1] ~ ~ ~ kill @s`);
	}catch(e){}
	}
}

function blockBreak(eventData){
checkForGlobalEntity();
try{
let block = eventData.block;
let blockLoc = block.location;
let x = blockLoc.x;
let y = blockLoc.y;
let z = blockLoc.z; 
let blockPermu = eventData.brokenBlockPermutation;
let dimension = eventData.dimension;
let player = eventData.player;
let tags = player.getTags();
let myJson = tags.find(tag => tag.includes('bb-{'));
let index;
let door1;
let door2;
let door3;
let door4;
let myNewJson;
	if(myJson){
	let myDb = tagToJson(myJson);
	index = myDb.blocks.findIndex(loc => loc.includes(`${x}:${y}:${z}`));
	if(index<=-1){
		let globalDb = getGlobalDb();
		let otherDb = globalDb.blocks.filter(db => !myDb.blocks.includes(db));
		let index2 = otherDb.findIndex(loc => loc.includes(`${x}:${y}:${z}`));	
		if(index2>=0){
		block.setPermutation(blockPermu);
		try{
		dimension.runCommand(`execute @e[x=${x},y=${y},z=${z},r=2,type=item,c=1] ~ ~ ~ kill @s`);
		}catch(e){}
		dimension.runCommand(`tellraw @a[name="${eventData.player.nameTag}"] {"rawtext":[{"text":"§c[Block Protection]You cannot destroy this block!"}]}`);	
		}else{
		}
	return;
	}
	//remove current tag
	player.removeTag(myJson);
	if(blockPermu.type.id.includes('door') && !blockPermu.type.id.includes('trap')){
		if(blockPermu.getProperty('upper_block_bit').value){
		myDb.blocks.splice(index,1);
		door3 = myDb.blocks.findIndex(loc => loc.includes(`${x}:${(y-1)}:${z}`));
		myDb.blocks.splice(door3,1);
		door4 = myDb.blocks.findIndex(loc => loc.includes(`${x}:${(y-2)}:${z}`));
		myDb.blocks.splice(door4,1);
		removeFromGlobal(x,y,z,true,"up");
		}else{
		myDb.blocks.splice(index,1);
		door2 = myDb.blocks.findIndex(loc => loc.includes(`${x}:${(y+1)}:${z}`));
		myDb.blocks.splice(door2,1);
		door3 = myDb.blocks.findIndex(loc => loc.includes(`${x}:${(y-1)}:${z}`));
		myDb.blocks.splice(door3,1);
		removeFromGlobal(x,y,z,true,"down");
		}
	}else{
		let doorBlockTop = dimension.getBlock(new BlockLocation(x,(y+1),z)).id;
		if(doorBlockTop.includes('door') && !doorBlockTop.includes('trap')){
		myDb.blocks.splice(index,1);
		door2 = myDb.blocks.findIndex(loc => loc.includes(`${x}:${(y+1)}:${z}`));
		myDb.blocks.splice(door2,1);
		door1 = myDb.blocks.findIndex(loc => loc.includes(`${x}:${(y+2)}:${z}`));
		myDb.blocks.splice(door1,1);
		removeFromGlobal(x,y,z,false,"top");
		}else{
		myDb.blocks.splice(index,1);
		removeFromGlobal(x,y,z,false,"none");
		}
	}
	myNewJson = jsonToTag(myDb);
	player.addTag(myNewJson);	
	}else{
	//dimension.runCommand(`say error`);	
	}
	}catch(e){
	//world.getDimension(`overworld`).runCommand(`say "${e}"`);
	}
}

function blockPlace(eventData){
checkForGlobalEntity();
let block = eventData.block;
if(block.id == 'minecraft:chest' || block.id == 'minecraft:tnt' || block.id == 'minecraft:trapped_chest' || block.id == 'minecraft:undyed_shulker_box' || block.id == 'minecraft:shulker_box'  || block.id == 'minecraft:barrel'  || block.id == 'minecraft:dropper'  || block.id == 'minecraft:dispense'  || block.id == 'minecraft:furnace') return;
let blockLoc = block.location;
let x = blockLoc.x;
let y = blockLoc.y;
let z = blockLoc.z;
let blockPermu = block.permutation;
let dimension = eventData.dimension;
let player = eventData.player;

let tags = player.getTags();
let myJson = tags.find(tag => tag.includes('bb-{'));
if(block.id.includes('door') && !block.id.includes('trap')){
addToGlobal(x,y,z,true);
	if(!myJson){
	let newJson = 'bb-{xyblocksxy:[]}';
	let myDb = tagToJson(newJson);
	myDb.blocks.push(`${x}:${y}:${z}`);
	myDb.blocks.push(`${x}:${(y+1)}:${z}`);
	myDb.blocks.push(`${x}:${(y-1)}:${z}`);
	let newTag = jsonToTag(myDb);
	player.addTag(newTag);
	return;
	}
let myDb = tagToJson(myJson);
myDb.blocks.push(`${x}:${y}:${z}`);
myDb.blocks.push(`${x}:${(y+1)}:${z}`);
myDb.blocks.push(`${x}:${(y-1)}:${z}`);
myJson = jsonToTag(myDb);
player.removeTag(tags.find(tag => tag.includes('bb-{')));
player.addTag(myJson);
}else{
addToGlobal(x,y,z,false);
	if(!myJson){
	let newJson = 'bb-{xyblocksxy:[]}';
	let myDb = tagToJson(newJson);
	myDb.blocks.push(`${x}:${y}:${z}`);
	let newTag = jsonToTag(myDb);
	player.addTag(newTag);
	return;
	}
let myDb = tagToJson(myJson);
myDb.blocks.push(`${x}:${y}:${z}`);
myJson = jsonToTag(myDb);
player.removeTag(tags.find(tag => tag.includes('bb-{')));
player.addTag(myJson);
}
}

function checkForGlobalEntity(){
let globalBlockRec = world.getDimension(`overworld`).getEntitiesAtBlockLocation(new BlockLocation(0,-64,0));
let globalEntity = globalBlockRec.find(entity => entity.id.includes('bp:globalrec'));
if(globalBlockRec.length<=0 || !globalEntity){
let entityRec = world.getDimension('overworld').spawnEntity('bp:globalrec',new BlockLocation(0,-64,0));
entityRec.addTag('bb-{xyblocksxy:[]}');
return;	
}	
}

function addToGlobal(x,y,z,door){
let globalBlockRec = world.getDimension(`overworld`).getEntitiesAtBlockLocation(new BlockLocation(0,-64,0));
let globalEntity = globalBlockRec[0];
let tags = globalEntity.getTags();
let globalJson = tags.find(tag => tag.includes('bb-{'));
	if(!globalJson){
	let newJson = 'bb-{xyblocksxy:[]}';
	let globalDb = tagToJson(newJson);
	globalDb.blocks.push(`${x}:${y}:${z}`);
		if(door){
		globalDb.blocks.push(`${x}:${(y+1)}:${z}`);
		globalDb.blocks.push(`${x}:${(y-1)}:${z}`);
		}
	let newTag = jsonToTag(globalDb);
	globalEntity.addTag(newTag);
	return;
	}
let globalDb = tagToJson(globalJson);
globalDb.blocks.push(`${x}:${y}:${z}`);
	if(door){
	globalDb.blocks.push(`${x}:${(y+1)}:${z}`);
	globalDb.blocks.push(`${x}:${(y-1)}:${z}`);	
	}
globalJson = jsonToTag(globalDb);
globalEntity.removeTag(tags.find(tag => tag.includes('bb-{')));
globalEntity.addTag(globalJson);
}

function getGlobalDb(){
let globalBlockRec = world.getDimension(`overworld`).getEntitiesAtBlockLocation(new BlockLocation(0,-64,0));
let globalEntity = globalBlockRec[0];
let tags = globalEntity.getTags();	
let globalJson = tags.find(tag => tag.includes('bb-{'));
	if(globalJson){
	return tagToJson(globalJson);	
	}
}

function removeFromGlobal(x,y,z,door,doorPosition){
let globalBlockRec = world.getDimension(`overworld`).getEntitiesAtBlockLocation(new BlockLocation(0,-64,0));
let globalEntity = globalBlockRec[0];
let tags = globalEntity.getTags();	
let globalJson = tags.find(tag => tag.includes('bb-{'));
let index;
if(globalJson){
	let globalDb = tagToJson(globalJson);
	index = globalDb.blocks.findIndex(loc => loc.includes(`${x}:${y}:${z}`));	
	if(index<=-1){
		return;
	}
	if(door){
		if(doorPosition == 'up'){
		globalDb.blocks.splice(index,1);
		index = globalDb.blocks.findIndex(loc => loc.includes(`${x}:${(y-1)}:${z}`));	
		globalDb.blocks.splice(index,1);
		index = globalDb.blocks.findIndex(loc => loc.includes(`${x}:${(y-2)}:${z}`));	
		globalDb.blocks.splice(index,1);
		}else{
		globalDb.blocks.splice(index,1);
		index = globalDb.blocks.findIndex(loc => loc.includes(`${x}:${(y+1)}:${z}`));	
		globalDb.blocks.splice(index,1);	
		index = globalDb.blocks.findIndex(loc => loc.includes(`${x}:${(y-1)}:${z}`));	
		globalDb.blocks.splice(index,1);	
		}
		
	}else{
		if(doorPosition == 'top'){
		globalDb.blocks.splice(index,1);
		index = globalDb.blocks.findIndex(loc => loc.includes(`${x}:${(y+1)}:${z}`));	
		globalDb.blocks.splice(index,1);	
		index = globalDb.blocks.findIndex(loc => loc.includes(`${x}:${(y+2)}:${z}`));	
		globalDb.blocks.splice(index,1);		
		}else{
		globalDb.blocks.splice(index,1);
		}
		}
		globalJson = jsonToTag(globalDb);
		globalEntity.removeTag(tags.find(tag => tag.includes('bb-{')));
		globalEntity.addTag(globalJson);
	}	
}

function tagToJson(myJson){
myJson = myJson.replace(/xy/gi,'"');
myJson = myJson.replace(/z/gi,',');
myJson = myJson.replace(/bb-/gi,'');	
return JSON.parse(myJson);
}

function jsonToTag(newTag){
newTag = JSON.stringify(newTag)
newTag = newTag.replace(/["]/gi,'xy');
newTag = newTag.replace(/[,]/gi,'z');
newTag = "bb-" + newTag;
return newTag;	
}